{*****************************************************************************
   This source code copyrighted 1991 by the Gamers Programming Workshop.
   Liscense is granted for copying, modification, and distribution, as well as
   re-use, provided that this header remains unchanged, and no fee is charged 
   for this code beyond disk costs.

   by: Mark Betz 76605,2346
*****************************************************************************}

Program AnimTst5;
uses
	CRT, DOS, PCXTOOL;

var
	FrameBuff  : array[0..44070] of byte; {buffers for frame bitmaps}
    FRMBuff    : pointer;
	FrameSize  : word;
    f_file   : file;
    FrameWid : word;
    FrameDep : word;
    TopFrame : byte;
    PCXBuff : pointer;

{$L ANIM5.OBJ}                   {NOTE: Path hardcoded!!!!!}

Procedure _Animate(x,y : word); external;

begin
    clrscr;                                {clear the screen}
	PcxBuff := LoadPcx('rehack.pcx');   {function returns pointer to buf}
	InitGraphics;                          {set up mode 19 graphics}
	FadeInPcx(PcxBuff);                  {fade the picture in}
    assign(f_file,'frames.grf');
    reset(f_file,1);
    blockread(f_file,FrameBuff,44064);
    close(f_file);
    FRMBuff := ptr(seg(FrameBuff),ofs(FrameBuff));
    FrameWid := 48;
    FrameDep := 52;
    FrameSize := 2592;
    TopFrame  := 16;
    _Animate(127,20);                      {call the assembler module
    FadeOutPcx;
    FreePcxMem(PCXBuff);                 {free the buffer}
	RestoreText;                           {reset to mode co80}
    clrscr;                                {clear screen}
end.                                       {goodbye}


