#ifndef _EVENTQ_HPP
#define _EVENTQ_HPP

// ------------------------------------------------------------------
// File:		EVENTQ.HPP
// Path:		...\REHACK\EVENT\EVENTQ.HPP
// Version:		0.01
// Author:		Pat Reilly
// CIS Id:		71333,2764
// Created On:	6/18/93
// Modified On:	6/28/93
// Description:	EventQueue class for REHACK. See EVENTQ.TXT for
//				more details.
// Tabs:		4
// ------------------------------------------------------------------

#ifndef _EVENT_HPP
#include "..\EVENT\EVENT.HPP"
#endif

const StdEventQueueSize = 16;

class EventQueue
{
public:
	EventQueue();

	void put(const Event&);
	bool get(Event&);

protected:

	friend void makeInc();

	Event buffer[StdEventQueueSize];
	int head;
	int tail;
};

#endif	// _EVENTQ_HPP
