//---------------------------------------------------------------------------
//
//     File:           GENERAL.HPP
//     Path:           ...\REHACK\GENERAL\GENERAL.HPP
//     Version:                1.01
//     Author:         Bob Provencher/GD SL
//     CIS Id:         71621,2632
//     Created On:     6/12/93
//     Modified On:    6/22/93
//     Description:    General function definitions for Rehack.
//     Tabs:           5
//
//---------------------------------------------------------------------------

#ifndef _GENERAL_HPP
#define _GENERAL_HPP

template <class T> const T& min( const T& a, const T& b )
{
        return a < b ? a : b;
}

template <class T> const T& max( const T& a, const T& b )
{
        return a > b ? a : b;
}

inline bool xor( const bool a, const bool b )
{
	return bool( ( a || b ) && !( a && b ) );
}

#endif
